------------------------------------------------
-- English localization for IsJustaGamepadInventory
------------------------------------------------
--	Create global custom ITEMFILTERTYPEs dynamically based on ITEMFILTERTYPE_ITERATION_END
-- ITEMFILTERTYPE_ITERATION_END = 26
ITEMFILTERTYPE_CONTAINER = ITEMFILTERTYPE_ITERATION_END + 1
ITEMFILTERTYPE_FOOD_DRINK = ITEMFILTERTYPE_CONTAINER + 1
ITEMFILTERTYPE_MAPS = ITEMFILTERTYPE_FOOD_DRINK + 1
ITEMFILTERTYPE_POTION = ITEMFILTERTYPE_MAPS + 1
ITEMFILTERTYPE_RECIPE_STYLE_PAGE = ITEMFILTERTYPE_POTION + 1
ITEMFILTERTYPE_REPAIR = ITEMFILTERTYPE_RECIPE_STYLE_PAGE + 1
ITEMFILTERTYPE_SIEGE = ITEMFILTERTYPE_REPAIR + 1
ITEMFILTERTYPE_STOLEN = ITEMFILTERTYPE_SIEGE + 1
ITEMFILTERTYPE_TREASURE = ITEMFILTERTYPE_STOLEN + 1
ITEMFILTERTYPE_WRIT = ITEMFILTERTYPE_TREASURE + 1
ITEMFILTERTYPE_FRAGMENT = ITEMFILTERTYPE_WRIT + 1

-- ITEM_TYPE_DISPLAY_CATEGORY_MAX_VALUE = 40
ITEM_TYPE_DISPLAY_CATEGORY_CRAFTED = ITEM_TYPE_DISPLAY_CATEGORY_MAX_VALUE + 1

-- localized strings
local useCategory = "Use <<1>> Category"
local useCategoryTooltip = "Enabled: adds a dynamic category for <<1>>."
local plural = "<<1>>s"

local containerString = GetString(SI_ITEMTYPEDISPLAYCATEGORY26)
local foofDrinkString = zo_strformat(SI_UNIT_FRAME_BARVALUE, GetString(SI_ITEMTYPEDISPLAYCATEGORY19), GetString(SI_ITEMTYPEDISPLAYCATEGORY20))
local potionString = GetString(SI_ITEMTYPEDISPLAYCATEGORY22)
local recipesString = zo_strformat(SI_UNIT_FRAME_BARVALUE, GetString(SI_ITEMTYPEDISPLAYCATEGORY21), GetString(SI_ITEMTYPEDISPLAYCATEGORY24))
local repairKitsString = GetString(SI_HOOK_POINT_STORE_REPAIR_KIT_HEADER):gsub(":$", "")
local siegeString = GetString(SI_ITEMTYPEDISPLAYCATEGORY32)
local treasuresString = zo_strformat(plural, GetString(SI_ITEMTYPE56))
local writsString = GetString(SI_CUSTOMERSERVICESUBMITFEEDBACKSUBCATEGORIES212)
local stolenString = GetString(SI_GAMEPAD_ITEM_STOLEN_LABEL)
local fragmentsString = GetString(SI_ANTIQUITY_FRAGMENTS)

local mapsSurveyString = zo_strformat(SI_UNIT_FRAME_BARVALUE,  
	zo_strformat(plural, GetString(SI_SPECIALIZEDITEMTYPE101)), zo_strformat(plural, GetString(SI_SPECIALIZEDITEMTYPE100))
)
--local surveyString = zo_strformat(plural, GetString(SI_SPECIALIZEDITEMTYPE101):gsub(" .*$", ''))
--surveyString = zo_strformat(SI_UNIT_NAME, surveyString)

-- custom strings
local destroyAllJunkWarning = GetString(SI_DESTROY_ALL_JUNK) .. '\n\n' .. ZO_ERROR_COLOR:Colorize('This action will destroy <<1>> %s.')
local strings = {
	SI_IJA_GPINVENTORY_CATEGORIES_HEADER			= "Sorted Categories",
	SI_IJA_GPINVENTORY_CATEGORIE_OPTIONS			= "Category options",
	SI_IJA_GPINVENTORY_BANK_OPTIONS					= "Bank junk sort Options",

	SI_IJA_GPINVENTORY_SORTBANK_WITHDRAW			= "Bank Withdraw",
	SI_IJA_GPINVENTORY_SORTBANK_WITHDRAW_TOOLTIP	= "Enabled: Sorts junk in bank withdraw list to bottom.",

	SI_IJA_GPINVENTORY_SORTBANK_DEPOSIT				= "Bank Deposit",
	SI_IJA_GPINVENTORY_SORTBANK_DEPOSIT_TOOLTIP		= "Enabled: sorts junk in bank and guild bank deposit lists to bottom.",
	
	SI_IJA_GPINVENTORY_PLURAL = plural,
	
	SI_IJA_GPINVENTORY_DESTROY_ALL_WARNING1			= string.format(destroyAllJunkWarning, 'item'),
	SI_IJA_GPINVENTORY_DESTROY_ALL_WARNING2			= string.format(destroyAllJunkWarning, 'items'),
	
	SI_IJA_GPINVENTORY_SORTJUNK1					= GetString(SI_ITEMTYPE0),
	SI_IJA_GPINVENTORY_SORTJUNK2					= "To Top",
	SI_IJA_GPINVENTORY_SORTJUNK3					= "To Bottom",
}
IJA_GPINVENTORY_LOCALIZEDSTRINGS = {category = {}, tooltips = {}}
IJA_GPINVENTORY_LOCALIZEDSTRINGS.useCategory			= useCategory
IJA_GPINVENTORY_LOCALIZEDSTRINGS.useCategoryTooltip		= useCategoryTooltip
IJA_GPINVENTORY_LOCALIZEDSTRINGS.plural					= plural

IJA_GPINVENTORY_LOCALIZEDSTRINGS.category.container		= containerString
IJA_GPINVENTORY_LOCALIZEDSTRINGS.category.foofDrink		= foofDrinkString
IJA_GPINVENTORY_LOCALIZEDSTRINGS.category.junk			= GetString(SI_ITEMFILTERTYPE9)
IJA_GPINVENTORY_LOCALIZEDSTRINGS.category.potion		= potionString
IJA_GPINVENTORY_LOCALIZEDSTRINGS.category.mapsSurvey	= mapsSurveyString
IJA_GPINVENTORY_LOCALIZEDSTRINGS.category.recipes		= recipesString
IJA_GPINVENTORY_LOCALIZEDSTRINGS.category.repairKits	= repairKitsString
IJA_GPINVENTORY_LOCALIZEDSTRINGS.category.siege			= siegeString
IJA_GPINVENTORY_LOCALIZEDSTRINGS.category.stolen		= stolenString
IJA_GPINVENTORY_LOCALIZEDSTRINGS.category.treasures		= treasuresString
IJA_GPINVENTORY_LOCALIZEDSTRINGS.category.writs			= writsString
IJA_GPINVENTORY_LOCALIZEDSTRINGS.category.fragments		= fragmentsString

IJA_GPINVENTORY_LOCALIZEDSTRINGS.tooltips.container		= 'select containers'
IJA_GPINVENTORY_LOCALIZEDSTRINGS.tooltips.foofDrink		= foofDrinkString
IJA_GPINVENTORY_LOCALIZEDSTRINGS.tooltips.junk			= 'items marked as junk'
IJA_GPINVENTORY_LOCALIZEDSTRINGS.tooltips.potion		= potionString
IJA_GPINVENTORY_LOCALIZEDSTRINGS.tooltips.mapsSurvey	= mapsSurveyString
IJA_GPINVENTORY_LOCALIZEDSTRINGS.tooltips.recipes		= recipesString
IJA_GPINVENTORY_LOCALIZEDSTRINGS.tooltips.repairKits	= 'slot-able repair kits'
IJA_GPINVENTORY_LOCALIZEDSTRINGS.tooltips.siege			= 'AVA items'
IJA_GPINVENTORY_LOCALIZEDSTRINGS.tooltips.stolen		= 'stolen items'
IJA_GPINVENTORY_LOCALIZEDSTRINGS.tooltips.treasures		= '\"Sell to merchant\" treasure items'
IJA_GPINVENTORY_LOCALIZEDSTRINGS.tooltips.writs			= 'writs'
IJA_GPINVENTORY_LOCALIZEDSTRINGS.tooltips.fragments		= fragmentsString:lower()

-- used for categoryList item
strings["SI_ITEMFILTERTYPE" .. ITEMFILTERTYPE_CONTAINER] = containerString
strings["SI_ITEMFILTERTYPE" .. ITEMFILTERTYPE_FOOD_DRINK] = foofDrinkString
strings["SI_ITEMFILTERTYPE" .. ITEMFILTERTYPE_POTION] = potionString
strings["SI_ITEMFILTERTYPE" .. ITEMFILTERTYPE_RECIPE_STYLE_PAGE] = recipesString
strings["SI_ITEMFILTERTYPE" .. ITEMFILTERTYPE_REPAIR] = repairKitsString
strings["SI_ITEMFILTERTYPE" .. ITEMFILTERTYPE_SIEGE] = siegeString
strings["SI_ITEMFILTERTYPE" .. ITEMFILTERTYPE_STOLEN] = stolenString
strings["SI_ITEMFILTERTYPE" .. ITEMFILTERTYPE_TREASURE] = treasuresString
strings["SI_ITEMFILTERTYPE" .. ITEMFILTERTYPE_WRIT] = writsString
strings["SI_ITEMFILTERTYPE" .. ITEMFILTERTYPE_FRAGMENT] = fragmentsString

--strings["SI_ITEMFILTERTYPE" .. ITEMFILTERTYPE_MAPS] = zo_strformat(SI_UNIT_FRAME_BARVALUE, surveyString, GetString(SI_MAIN_MENU_MAP) .. "s")
strings["SI_ITEMFILTERTYPE" .. ITEMFILTERTYPE_MAPS] = mapsSurveyString

strings["SI_ITEMTYPEDISPLAYCATEGORY" .. ITEM_TYPE_DISPLAY_CATEGORY_CRAFTED] = GetString(SI_ITEM_FORMAT_STR_CRAFTED) -- "Crafted"

--[[
ITEM_LIST_SORT_TYPE_JUNK = ITEM_LIST_SORT_TYPE_ITERATION_END + 1
ITEM_LIST_SORT_TYPE_ITERATION_END = ITEM_LIST_SORT_TYPE_JUNK
strings['SI_ITEMLISTSORTTYPE' .. ITEM_LIST_SORT_TYPE_JUNK] = GetString(SI_ITEMFILTERTYPE9)
]]
for stringId, stringValue in pairs(strings) do
	ZO_CreateStringId(stringId, stringValue)
	SafeAddVersion(stringId, 1)
end
